%MACRO DISP1(A1DISP1=,
	A2DISP1=,
	A3DISP1=);

data _null_;
set mdisp1;
CALL SYMPUT("Q",PUT(LQ,4.1));
CALL SYMPUT("NUMBER",PUT(LNUMBER,4.0));
CALL SYMPUT("LBOUND",PUT(LLBOUND,4.1));
CALL SYMPUT("CILEVEL",PUT(LCILEVEL,4.1));
run;


%IF %UPCASE(&A2DISP1)=Y %THEN %DO;
data _null_;
set ev1;
CALL SYMPUT("ULOW",PUT(LULOW,4.0));
CALL SYMPUT("UHIGH",PUT(LUHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(LUINCRE,4.0));
CALL SYMPUT("UDIV",PUT(LUDIV,4.0));
CALL SYMPUT("CVLOW",PUT(LCVLOW,4.0));
CALL SYMPUT("CVHIGH",PUT(LCVHIGH,4.0));
CALL SYMPUT("CVINCRE",PUT(LCVINCRE,4.0));
CALL SYMPUT("CVDIV",PUT(LCVDIV,4.0)); 
RUN;
%END;
%ELSE %IF %UPCASE(&A2DISP1)=N %THEN %DO;
data _null_;
CALL SYMPUT("ULOW",PUT(950,4.0));
CALL SYMPUT("UHIGH",PUT(1000,4.0));
CALL SYMPUT("UINCRE",PUT(50,4.0));
CALL SYMPUT("UDIV",PUT(10,4.0));
CALL SYMPUT("CVLOW",PUT(10,4.0));
CALL SYMPUT("CVHIGH",PUT(40,4.0));
CALL SYMPUT("CVINCRE",PUT(30,4.0));
CALL SYMPUT("CVDIV",PUT(10,4.0)); 
RUN;
%END;

%IF %UPCASE(&A3DISP1)=Y %THEN %DO;
data _null_;
set smp1;
CALL SYMPUT("MEAN",PUT(LMEAN,6.2));
CALL SYMPUT("CV",PUT(LCV,6.2)); 
CALL SYMPUT("LCV",PUT(LCV,6.2)); 
run;
%END;
%ELSE %IF %UPCASE(&A3DISP1)=N %THEN %DO;
data _null_;
CALL SYMPUT("MEAN",PUT(100,6.2));
CALL SYMPUT("CV",PUT(4,6.2)); 
CALL SYMPUT("LCV",PUT(4,6.2)); 
run;
%END;

%MACRO COMPUTE;
   F1 = (1 - PROBNORM((5 - LLU)/SIGMA)) ** 6;
   SN2 = SQRT(12);
   PM2 = PROBNORM (SN2 * -LLU / SIGMA);
   PB2 = 1 - PROBNORM ((-15 - LLU) / SIGMA);
   F2 = PB2 ** 12 - PM2;
   SN3 = SQRT(24);
   PM3 = PROBNORM (SN3 * -LLU / SIGMA);
   P2 = PROBNORM ((-15 - LLU) / SIGMA) - PROBNORM ((-25 - LLU) / SIGMA);
   P3 = 1 - PROBNORM ((-15 - LLU) / SIGMA);
   F3 = P3**24 + 24*P2*P3**23 + 276*P2*P2*P3**22 - PM3;
   OVERBD = MAX(F1, F2, F3);
%mend compute;
%MACRO CALDISP1;
DATA D1ONE;
   Q = &Q;
   LIM = 100 - Q;
   N = &NUMBER;
   D=0.2;
   Z = PROBIT(SQRT(&CILEVEL / 100));
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
   STARTSD = 0.002;
   DO MEANADJ = D TO LIM BY D;
      BEGIN = STARTSD;
    DO SAMPSD = BEGIN TO 60.0 BY 0.001;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEANADJ - Z *SIGMA / SQRT(N);
%COMPUTE
   IF OVERBD < &LBOUND/100 AND SAMPSD <= 0.00201 then do;
   CV = 0; OUTPUT; SAMPLSD = 65.0; GOTO NEXT; END;
   IF OVERBD < &LBOUND/100 THEN DO;
      SAMPSD = SAMPSD - 0.001;
      STARTSD = SAMPSD;
      MEAN = MEANADJ + Q;
      CV = 100 * SAMPSD / MEAN;
       OUTPUT;
       SAMPSD = 65.0;
       END;
    NEXT:
     END;
    END;
  KEEP CV MEAN ;
PROC SORT DATA=D1ONE; BY MEAN;
DATA
     ONE(RENAME = (MEAN = X1 CV = CV1))
     TWO(RENAME = (MEAN = X2 CV = CV2))
     THREE(RENAME = (MEAN = X3 CV = CV3))
     FOUR(RENAME = (MEAN = X4 CV = CV4))
     FIVE(RENAME = (MEAN = X5 CV = CV5));
 SET D1ONE;
    Q = &Q;
    LIM = 100 - Q;
 IF Q                  < MEAN <= Q+ LIM/5   + 0.0001 THEN OUTPUT ONE;
 IF Q+LIM/5   + 0.0001 < MEAN <= Q+ 2*LIM/5 + 0.0001 THEN OUTPUT TWO;
 IF Q+2*LIM/5 + 0.0001 < MEAN <= Q+ 3*lIM/5 + 0.0001 THEN OUTPUT THREE;
 IF Q+3*LIM/5 + 0.0001 < MEAN <= Q+ 4*LIM/5 + 0.0001 THEN OUTPUT FOUR;
 IF Q+4*LIM/5 + 0.0001 < MEAN <= Q+ LIM     + 0.0001 THEN OUTPUT FIVE;
DATA D1ALL;
   MERGE ONE TWO THREE FOUR FIVE;
RUN;

%MEND CALDISP1;

%MACRO PRTDISP1;
OPTIONS MISSING = ' ' NODATE NONUMBER;
OPTIONS LS=132;
PROC PRINT DATA=D1ALL SPLIT = '*';
   FORMAT CV1 CV2 CV3 CV4 CV5 5.2;
   LABEL
         X1 = '  MEAN*(% CLAIM)'
         X2 = '  MEAN*(% CLAIM)'
         X3 = '  MEAN*(% CLAIM)'
         X4 = '  MEAN*(% CLAIM)'
         X5 = '  MEAN*(% CLAIM)'
         CV1 = 'CV*(%)'
         CV2 = 'CV*(%)'
         CV3 = 'CV*(%)'
         CV4 = 'CV*(%)'
         CV5 = 'CV*(%)';
      VAR CV1 X2 CV2 X3 CV3 X4 CV4 X5 CV5;
      ID X1;
TITLE "ACCEPTANCE LIMITS FOR DISSOLUTION (N = &NUMBER, Q = &Q)";
TITLE2 'SAMPLING PLAN 1';
TITLE3 "(MEETING LIMITS GUARANTEES WITH &CILEVEL % ASSURANCE,";
TITLE4 "THAT AT LEAST &LBOUND% OF ALL FUTURE SAMPLES TESTED";
TITLE5 'FOR DISSOLUTION WILL PASS THE USP TEST)';
TITLE6 "TABLE ENTRY IS UPPER LIMIT ON CV OF &NUMBER DISSOLUTION ASSAYS";
%MEND PRTDISP1;


%MACRO EVDISP1;


DATA DIONE;
   SET d1one;
   x = mean;
   std = x*cv/100;
   N = &NUMBER;

%MACRO SIGDISP1;

   %DO CV = &CVLOW %TO &CVHIGH %BY &CVINCRE;
      %DO U = &ULOW %TO &UHIGH %BY &UINCRE;

         DATA D1SAVE;
            SET DIONE END = LAST;
            U = &U / &UDIV;
            CV = &CV / &CVDIV;
            SIGMA = U * CV / 100;
            PMEAN = PROBNORM((x - U) * SQRT(N) / SIGMA)
                    - PROBNORM((LAG(X) - U) * SQRT(N) / SIGMA);
            AVEHT = (STD + LAG(STD)) / 2;
            PSTD = PROBCHI((N - 1) * AVEHT * AVEHT
                   / ( SIGMA * SIGMA), N - 1);
            PT = PMEAN * PSTD ;
            PTRAP + PT;
            IF X > 99.9 THEN DO;
               PMEAN = 1 - PROBNORM((X - U) * SQRT (N) / SIGMA);
               PSTD = PROBCHI((N - 1) * STD * STD
                      / ( SIGMA * SIGMA), N - 1);
               PT = PMEAN * PSTD;
               PTRAP + PT;
            END;
            IF LAST THEN OUTPUT;
         RUN;

PROC APPEND BASE = D1SAVALL DATA = D1SAVE;

       %END;
    %END;

%MEND SIGDISP1;

%SIGDISP1

PROC PRINT DATA = D1SAVALL split = '*';
   label ptrap = 'PROBABILITY*OF*PASSING';
   VAR CV PTRAP;
   ID U;
TITLE  "ACCEPTANCE LIMITS FOR DISSOLUTION (N = &NUMBER, Q = &Q)";
TITLE2 'SAMPLING PLAN 1';
TITLE3 'PROBABILITY OF PASSING ACCEPTANCE LIMIT TABLE';
TITLE4 "CONFIDENCE LEVEL = &CILEVEL AND LOWER BOUND = &LBOUND";
RUN;
%MEND EVDISP1;

%MACRO SMPDISP1;

DATA DI1SMP;
LABEL OVERBD = 'OVERALL LOWER BOUND'
       MEAN = 'SAMPLE MEAN(%CLAIM)';
   Q = &Q;
   N = &NUMBER;
   CILEVEL = &CILEVEL;
   Z = PROBIT(SQRT(&CILEVEL / 100));
   N = &NUMBER;
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
      MEAN = &MEAN;
      MEANADJ = MEAN - Q;
      CV = &LCV;
      SAMPSD= &MEAN * CV/100;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEANADJ - Z *SIGMA / SQRT(N);
%COMPUTE
PROC PRINT SPLIT = '*';
  LABEL SAMPSD = 'SAMPLE*STD DEV*(% CLAIM)'
        MEAN = 'SAMPLE* MEAN*(% CLAIM)'
        OVERBD = 'LOWER BOUND';

  ID MEAN;
  VAR SAMPSD CV OVERBD;
TITLE  "ACCEPTANCE LIMITS FOR DISSOLUTION (N = &NUMBER, Q = &Q)";
TITLE2 'SAMPLING PLAN 1';
TITLE3 "PROPORTION OF FUTURE SAMPLES PASSING THE USP TEST";
TITLE4 "FOR A GIVEN SAMPLE MEAN AND CV WITH &CILEVEL.% ASSURANCE";
run;
%MEND SMPDISP1;

%MACRO ANADISP1;

%IF %UPCASE(&A1DISP1)=Y OR %UPCASE(&A2DISP1)=Y %THEN %DO;
     %CALDISP1;
    %END;
%IF %UPCASE(&A1DISP1)=Y %THEN %DO;
      %PRTDISP1;
    %END;
%IF %UPCASE(&A2DISP1)=Y %THEN %DO;
      %EVDISP1;
PROC DATASETS LIBRARY = WORK;
   DELETE D1SAVALL;
    %END;
%IF %UPCASE(&A3DISP1)=Y %THEN %DO;
      %SMPDISP1;
    %END;
%MEND ANADISP1;

%ANADISP1
RUN;
%MEND DISP1;
%DISP1
